blob: 36ef7b37fc5dff82b19e85fae1e432fe5d07c96c [file] [log] [blame]
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +02001#!/bin/sh
Greg Kroah-Hartmanb2441312017-11-01 15:07:57 +01002# SPDX-License-Identifier: GPL-2.0
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +02003#
4# link vmlinux
5#
Masahiro Yamadad151e972019-01-17 09:10:04 +09006# vmlinux is linked from the objects selected by $(KBUILD_VMLINUX_OBJS) and
7# $(KBUILD_VMLINUX_LIBS). Most are built-in.a files from top-level directories
8# in the kernel tree, others are specified in arch/$(ARCH)/Makefile.
9# $(KBUILD_VMLINUX_LIBS) are archives which are linked conditionally
10# (not within --whole-archive), and do not require symbol indexes added.
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +020011#
12# vmlinux
13# ^
14# |
Masahiro Yamadad151e972019-01-17 09:10:04 +090015# +--< $(KBUILD_VMLINUX_OBJS)
16# | +--< init/built-in.a drivers/built-in.a mm/built-in.a + more
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +020017# |
Nicholas Piggin3a166fc2017-06-20 01:52:05 +100018# +--< $(KBUILD_VMLINUX_LIBS)
19# | +--< lib/lib.a + more
20# |
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +020021# +-< ${kallsymso} (see description in KALLSYMS section)
22#
23# vmlinux version (uname -v) cannot be updated during normal
24# descending-into-subdirs phase since we do not yet know if we need to
25# update vmlinux.
26# Therefore this step is delayed until just before final link of vmlinux.
27#
28# System.map is generated to document addresses of all kernel symbols
29
30# Error out on error
31set -e
32
Masahiro Yamada3ec8a5b2020-07-02 04:29:36 +090033LD="$1"
34KBUILD_LDFLAGS="$2"
35LDFLAGS_vmlinux="$3"
36
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +020037# Nice output in kbuild format
38# Will be supressed by "make -s"
39info()
40{
Masahiro Yamadac39013e2021-05-17 16:03:14 +090041 printf " %-7s %s\n" "${1}" "${2}"
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +020042}
43
Sami Tolvanena8cccdd2020-12-11 10:46:24 -080044# Generate a linker script to ensure correct ordering of initcalls.
45gen_initcalls()
46{
47 info GEN .tmp_initcalls.lds
48
49 ${PYTHON} ${srctree}/scripts/jobserver-exec \
50 ${PERL} ${srctree}/scripts/generate_initcall_order.pl \
51 ${KBUILD_VMLINUX_OBJS} ${KBUILD_VMLINUX_LIBS} \
52 > .tmp_initcalls.lds
53}
54
Sami Tolvanen38e89182020-12-11 10:46:20 -080055# If CONFIG_LTO_CLANG is selected, collect generated symbol versions into
56# .tmp_symversions.lds
57gen_symversions()
58{
59 info GEN .tmp_symversions.lds
60 rm -f .tmp_symversions.lds
61
62 for o in ${KBUILD_VMLINUX_OBJS} ${KBUILD_VMLINUX_LIBS}; do
63 if [ -f ${o}.symversions ]; then
64 cat ${o}.symversions >> .tmp_symversions.lds
65 fi
66 done
67}
68
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +020069# Link of vmlinux.o used for section mismatch analysis
70# ${1} output file
71modpost_link()
72{
Stephen Rothwella5967db2016-08-24 22:29:19 +100073 local objects
Sami Tolvanen38e89182020-12-11 10:46:20 -080074 local lds=""
Stephen Rothwella5967db2016-08-24 22:29:19 +100075
Nicholas Piggin6358d6e2018-02-11 00:25:03 +100076 objects="--whole-archive \
Masahiro Yamadad151e972019-01-17 09:10:04 +090077 ${KBUILD_VMLINUX_OBJS} \
Nicholas Piggin6358d6e2018-02-11 00:25:03 +100078 --no-whole-archive \
79 --start-group \
80 ${KBUILD_VMLINUX_LIBS} \
81 --end-group"
82
Sami Tolvanendc5723b2020-12-11 10:46:19 -080083 if [ -n "${CONFIG_LTO_CLANG}" ]; then
Sami Tolvanena8cccdd2020-12-11 10:46:24 -080084 gen_initcalls
85 lds="-T .tmp_initcalls.lds"
86
Sami Tolvanen38e89182020-12-11 10:46:20 -080087 if [ -n "${CONFIG_MODVERSIONS}" ]; then
88 gen_symversions
89 lds="${lds} -T .tmp_symversions.lds"
90 fi
91
Sami Tolvanendc5723b2020-12-11 10:46:19 -080092 # This might take a while, so indicate that we're doing
93 # an LTO link
94 info LTO ${1}
95 else
96 info LD ${1}
97 fi
98
Sami Tolvanen38e89182020-12-11 10:46:20 -080099 ${LD} ${KBUILD_LDFLAGS} -r -o ${1} ${lds} ${objects}
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200100}
101
Peter Zijlstra6804c1a2020-03-18 13:33:54 +0100102objtool_link()
103{
Sami Tolvanenb1a1a1a2020-04-13 16:10:13 -0700104 local objtoolcmd;
Peter Zijlstra6804c1a2020-03-18 13:33:54 +0100105 local objtoolopt;
106
Sami Tolvanenb1a1a1a2020-04-13 16:10:13 -0700107 if [ "${CONFIG_LTO_CLANG} ${CONFIG_STACK_VALIDATION}" = "y y" ]; then
108 # Don't perform vmlinux validation unless explicitly requested,
109 # but run objtool on vmlinux.o now that we have an object file.
110 if [ -n "${CONFIG_UNWINDER_ORC}" ]; then
111 objtoolcmd="orc generate"
112 fi
113
114 objtoolopt="${objtoolopt} --duplicate"
115
116 if [ -n "${CONFIG_FTRACE_MCOUNT_USE_OBJTOOL}" ]; then
117 objtoolopt="${objtoolopt} --mcount"
118 fi
119 fi
120
Peter Zijlstra6804c1a2020-03-18 13:33:54 +0100121 if [ -n "${CONFIG_VMLINUX_VALIDATION}" ]; then
Sami Tolvanenb1a1a1a2020-04-13 16:10:13 -0700122 objtoolopt="${objtoolopt} --noinstr"
123 fi
124
125 if [ -n "${objtoolopt}" ]; then
126 if [ -z "${objtoolcmd}" ]; then
127 objtoolcmd="check"
128 fi
129 objtoolopt="${objtoolopt} --vmlinux"
Peter Zijlstra6804c1a2020-03-18 13:33:54 +0100130 if [ -z "${CONFIG_FRAME_POINTER}" ]; then
131 objtoolopt="${objtoolopt} --no-fp"
132 fi
Sami Tolvanenb1a1a1a2020-04-13 16:10:13 -0700133 if [ -n "${CONFIG_GCOV_KERNEL}" ] || [ -n "${CONFIG_LTO_CLANG}" ]; then
Peter Zijlstra6804c1a2020-03-18 13:33:54 +0100134 objtoolopt="${objtoolopt} --no-unreachable"
135 fi
136 if [ -n "${CONFIG_RETPOLINE}" ]; then
137 objtoolopt="${objtoolopt} --retpoline"
138 fi
139 if [ -n "${CONFIG_X86_SMAP}" ]; then
140 objtoolopt="${objtoolopt} --uaccess"
141 fi
142 info OBJTOOL ${1}
Sami Tolvanenb1a1a1a2020-04-13 16:10:13 -0700143 tools/objtool/objtool ${objtoolcmd} ${objtoolopt} ${1}
Peter Zijlstra6804c1a2020-03-18 13:33:54 +0100144 fi
145}
146
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200147# Link of vmlinux
Andrii Nakryiko341dfcf2019-08-12 11:39:47 -0700148# ${1} - output file
Andrii Nakryiko618916a2019-09-05 10:59:38 -0700149# ${2}, ${3}, ... - optional extra .o files
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200150vmlinux_link()
151{
152 local lds="${objtree}/${KBUILD_LDS}"
Andrii Nakryiko618916a2019-09-05 10:59:38 -0700153 local output=${1}
Stephen Rothwella5967db2016-08-24 22:29:19 +1000154 local objects
Kees Cookaf73d782020-03-03 18:18:34 -0800155 local strip_debug
Rasmus Villemoes5cc12472021-03-05 10:27:07 +0100156 local map_option
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200157
Linus Torvaldsd7b08272019-09-20 08:36:47 -0700158 info LD ${output}
159
Andrii Nakryiko618916a2019-09-05 10:59:38 -0700160 # skip output file argument
161 shift
162
Kees Cookaf73d782020-03-03 18:18:34 -0800163 # The kallsyms linking does not need debug symbols included.
164 if [ "$output" != "${output#.tmp_vmlinux.kallsyms}" ] ; then
165 strip_debug=-Wl,--strip-debug
166 fi
167
Rasmus Villemoes5cc12472021-03-05 10:27:07 +0100168 if [ -n "${CONFIG_VMLINUX_MAP}" ]; then
169 map_option="-Map=${output}.map"
170 fi
171
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200172 if [ "${SRCARCH}" != "um" ]; then
Sami Tolvanendc5723b2020-12-11 10:46:19 -0800173 if [ -n "${CONFIG_LTO_CLANG}" ]; then
174 # Use vmlinux.o instead of performing the slow LTO
175 # link again.
176 objects="--whole-archive \
177 vmlinux.o \
178 --no-whole-archive \
179 ${@}"
180 else
181 objects="--whole-archive \
182 ${KBUILD_VMLINUX_OBJS} \
183 --no-whole-archive \
184 --start-group \
185 ${KBUILD_VMLINUX_LIBS} \
186 --end-group \
187 ${@}"
188 fi
Stephen Rothwella5967db2016-08-24 22:29:19 +1000189
Andrii Nakryiko618916a2019-09-05 10:59:38 -0700190 ${LD} ${KBUILD_LDFLAGS} ${LDFLAGS_vmlinux} \
Kees Cookaf73d782020-03-03 18:18:34 -0800191 ${strip_debug#-Wl,} \
Andrii Nakryiko618916a2019-09-05 10:59:38 -0700192 -o ${output} \
Rasmus Villemoes5cc12472021-03-05 10:27:07 +0100193 ${map_option} \
Stephen Rothwella5967db2016-08-24 22:29:19 +1000194 -T ${lds} ${objects}
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200195 else
Nicholas Piggin6358d6e2018-02-11 00:25:03 +1000196 objects="-Wl,--whole-archive \
Masahiro Yamadad151e972019-01-17 09:10:04 +0900197 ${KBUILD_VMLINUX_OBJS} \
Nicholas Piggin6358d6e2018-02-11 00:25:03 +1000198 -Wl,--no-whole-archive \
199 -Wl,--start-group \
200 ${KBUILD_VMLINUX_LIBS} \
201 -Wl,--end-group \
Andrii Nakryiko618916a2019-09-05 10:59:38 -0700202 ${@}"
Stephen Rothwella5967db2016-08-24 22:29:19 +1000203
Andrii Nakryiko618916a2019-09-05 10:59:38 -0700204 ${CC} ${CFLAGS_vmlinux} \
Kees Cookaf73d782020-03-03 18:18:34 -0800205 ${strip_debug} \
Andrii Nakryiko618916a2019-09-05 10:59:38 -0700206 -o ${output} \
Rasmus Villemoes5cc12472021-03-05 10:27:07 +0100207 ${map_option:+-Wl,${map_option}} \
Nicholas Piggin6358d6e2018-02-11 00:25:03 +1000208 -Wl,-T,${lds} \
209 ${objects} \
Stephen Rothwella5967db2016-08-24 22:29:19 +1000210 -lutil -lrt -lpthread
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200211 rm -f linux
212 fi
213}
214
Andrii Nakryikoe83b9f52019-04-02 09:49:50 -0700215# generate .BTF typeinfo from DWARF debuginfo
Andrii Nakryiko341dfcf2019-08-12 11:39:47 -0700216# ${1} - vmlinux image
217# ${2} - file to dump raw BTF data into
Andrii Nakryikoe83b9f52019-04-02 09:49:50 -0700218gen_btf()
219{
Andrii Nakryiko341dfcf2019-08-12 11:39:47 -0700220 local pahole_ver
Ilya Leoshkevichdb16c1f2021-04-13 21:00:43 +0200221 local extra_paholeopt=
Andrii Nakryikoe83b9f52019-04-02 09:49:50 -0700222
Andrii Nakryiko581b31c2019-05-05 17:10:33 -0700223 if ! [ -x "$(command -v ${PAHOLE})" ]; then
Chris Down2a67a6c2020-01-22 00:01:10 +0000224 echo >&2 "BTF: ${1}: pahole (${PAHOLE}) is not available"
Andrii Nakryiko341dfcf2019-08-12 11:39:47 -0700225 return 1
Andrii Nakryiko581b31c2019-05-05 17:10:33 -0700226 fi
227
Andrii Nakryikoe83b9f52019-04-02 09:49:50 -0700228 pahole_ver=$(${PAHOLE} --version | sed -E 's/v([0-9]+)\.([0-9]+)/\1\2/')
Lorenz Bauer21a85bd2020-06-08 10:42:57 +0100229 if [ "${pahole_ver}" -lt "116" ]; then
230 echo >&2 "BTF: ${1}: pahole version $(${PAHOLE} --version) is too old, need at least v1.16"
Andrii Nakryiko341dfcf2019-08-12 11:39:47 -0700231 return 1
Andrii Nakryikoe83b9f52019-04-02 09:49:50 -0700232 fi
233
Andrii Nakryiko341dfcf2019-08-12 11:39:47 -0700234 vmlinux_link ${1}
Kees Cookaf73d782020-03-03 18:18:34 -0800235
Andrii Nakryikoa0b82002021-06-28 19:41:34 -0700236 if [ "${pahole_ver}" -ge "118" ] && [ "${pahole_ver}" -le "121" ]; then
237 # pahole 1.18 through 1.21 can't handle zero-sized per-CPU vars
238 extra_paholeopt="${extra_paholeopt} --skip_encoding_btf_vars"
239 fi
Ilya Leoshkevichdb16c1f2021-04-13 21:00:43 +0200240 if [ "${pahole_ver}" -ge "121" ]; then
241 extra_paholeopt="${extra_paholeopt} --btf_gen_floats"
242 fi
243
Kees Cookaf73d782020-03-03 18:18:34 -0800244 info "BTF" ${2}
Javier Martinez Canillasff2e6ef2021-05-26 23:52:28 +0200245 LLVM_OBJCOPY="${OBJCOPY}" ${PAHOLE} -J ${extra_paholeopt} ${1}
Andrii Nakryiko341dfcf2019-08-12 11:39:47 -0700246
Fangrui Song90ceddc2020-03-18 15:27:46 -0700247 # Create ${2} which contains just .BTF section but no symbols. Add
248 # SHF_ALLOC because .BTF will be part of the vmlinux image. --strip-all
249 # deletes all symbols including __start_BTF and __stop_BTF, which will
250 # be redefined in the linker script. Add 2>/dev/null to suppress GNU
251 # objcopy warnings: "empty loadable segment detected at ..."
252 ${OBJCOPY} --only-section=.BTF --set-section-flags .BTF=alloc,readonly \
253 --strip-all ${1} ${2} 2>/dev/null
254 # Change e_type to ET_REL so that it can be used to link final vmlinux.
255 # Unlike GNU ld, lld does not allow an ET_EXEC input.
256 printf '\1' | dd of=${2} conv=notrunc bs=1 seek=16 status=none
Andrii Nakryikoe83b9f52019-04-02 09:49:50 -0700257}
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200258
Masahiro Yamada08beb662020-09-25 00:45:46 +0900259# Create ${2} .S file with all symbols from the ${1} object file
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200260kallsyms()
261{
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200262 local kallsymopt;
263
264 if [ -n "${CONFIG_KALLSYMS_ALL}" ]; then
James Hogan6895f972012-09-06 22:11:25 +0100265 kallsymopt="${kallsymopt} --all-symbols"
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200266 fi
267
Ard Biesheuvel4d5d5662016-03-15 14:58:12 -0700268 if [ -n "${CONFIG_KALLSYMS_ABSOLUTE_PERCPU}" ]; then
Rusty Russellc6bda7c2014-03-17 14:05:46 +1030269 kallsymopt="${kallsymopt} --absolute-percpu"
270 fi
271
Ard Biesheuvel2213e9a2016-03-15 14:58:19 -0700272 if [ -n "${CONFIG_KALLSYMS_BASE_RELATIVE}" ]; then
273 kallsymopt="${kallsymopt} --base-relative"
274 fi
275
Masahiro Yamada08beb662020-09-25 00:45:46 +0900276 info KSYMS ${2}
277 ${NM} -n ${1} | scripts/kallsyms ${kallsymopt} > ${2}
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200278}
279
Kees Cook8959e392019-08-13 08:15:32 -0700280# Perform one step in kallsyms generation, including temporary linking of
281# vmlinux.
282kallsyms_step()
283{
284 kallsymso_prev=${kallsymso}
Kees Cookaf73d782020-03-03 18:18:34 -0800285 kallsyms_vmlinux=.tmp_vmlinux.kallsyms${1}
286 kallsymso=${kallsyms_vmlinux}.o
Masahiro Yamada08beb662020-09-25 00:45:46 +0900287 kallsyms_S=${kallsyms_vmlinux}.S
Kees Cook8959e392019-08-13 08:15:32 -0700288
Linus Torvaldsd7b08272019-09-20 08:36:47 -0700289 vmlinux_link ${kallsyms_vmlinux} "${kallsymso_prev}" ${btf_vmlinux_bin_o}
Masahiro Yamada08beb662020-09-25 00:45:46 +0900290 kallsyms ${kallsyms_vmlinux} ${kallsyms_S}
291
292 info AS ${kallsyms_S}
293 ${CC} ${NOSTDINC_FLAGS} ${LINUXINCLUDE} ${KBUILD_CPPFLAGS} \
294 ${KBUILD_AFLAGS} ${KBUILD_AFLAGS_KERNEL} \
295 -c -o ${kallsymso} ${kallsyms_S}
Kees Cook8959e392019-08-13 08:15:32 -0700296}
297
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200298# Create map file with all symbols from ${1}
299# See mksymap for additional details
300mksysmap()
301{
302 ${CONFIG_SHELL} "${srctree}/scripts/mksysmap" ${1} ${2}
303}
304
Shile Zhang10916702019-12-04 08:46:31 +0800305sorttable()
Linus Torvalds1347a2ce2012-05-28 10:32:28 -0700306{
Shile Zhang10916702019-12-04 08:46:31 +0800307 ${objtree}/scripts/sorttable ${1}
Linus Torvalds1347a2ce2012-05-28 10:32:28 -0700308}
309
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200310# Delete output files in case of error
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200311cleanup()
312{
Andrii Nakryiko341dfcf2019-08-12 11:39:47 -0700313 rm -f .btf.*
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200314 rm -f .tmp_System.map
Sami Tolvanena8cccdd2020-12-11 10:46:24 -0800315 rm -f .tmp_initcalls.lds
Sami Tolvanen38e89182020-12-11 10:46:20 -0800316 rm -f .tmp_symversions.lds
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200317 rm -f .tmp_vmlinux*
318 rm -f System.map
319 rm -f vmlinux
Rasmus Villemoes5cc12472021-03-05 10:27:07 +0100320 rm -f vmlinux.map
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200321 rm -f vmlinux.o
Rasmus Villemoes0b956e22021-03-05 11:02:12 +0100322 rm -f .vmlinux.d
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200323}
324
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200325# Use "make V=1" to debug this script
326case "${KBUILD_VERBOSE}" in
327*1*)
328 set -x
329 ;;
330esac
331
332if [ "$1" = "clean" ]; then
333 cleanup
334 exit 0
335fi
336
337# We need access to CONFIG_ symbols
Masahiro Yamada94cf8ac2019-03-08 14:49:10 +0900338. include/config/auto.conf
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200339
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200340# Update version
341info GEN .version
Masahiro Yamada278ae602017-09-22 14:31:13 +0900342if [ -r .version ]; then
343 VERSION=$(expr 0$(cat .version) + 1)
344 echo $VERSION > .version
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200345else
Masahiro Yamada278ae602017-09-22 14:31:13 +0900346 rm -f .version
347 echo 1 > .version
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200348fi;
349
350# final build of init/
Masahiro Yamada083bc0e2020-02-11 05:06:34 +0900351${MAKE} -f "${srctree}/scripts/Makefile.build" obj=init need-builtin=1
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200352
Nicholas Pigginabac4c82016-11-24 03:41:43 +1100353#link vmlinux.o
Nicholas Pigginabac4c82016-11-24 03:41:43 +1100354modpost_link vmlinux.o
Peter Zijlstra6804c1a2020-03-18 13:33:54 +0100355objtool_link vmlinux.o
Nicholas Pigginabac4c82016-11-24 03:41:43 +1100356
357# modpost vmlinux.o to check for section mismatches
Masahiro Yamadaa7215882019-07-31 00:59:02 +0900358${MAKE} -f "${srctree}/scripts/Makefile.modpost" MODPOST_VMLINUX=1
Nicholas Pigginabac4c82016-11-24 03:41:43 +1100359
Alexey Gladkov898490c2019-04-29 18:11:14 +0200360info MODINFO modules.builtin.modinfo
361${OBJCOPY} -j .modinfo -O binary vmlinux.o modules.builtin.modinfo
Masahiro Yamada8b41fc42019-12-19 17:33:29 +0900362info GEN modules.builtin
363# The second line aids cases where multiple modules share the same object.
364tr '\0' '\n' < modules.builtin.modinfo | sed -n 's/^[[:alnum:]:_]*\.file=//p' |
365 tr ' ' '\n' | uniq | sed -e 's:^:kernel/:' -e 's/$/.ko/' > modules.builtin
Alexey Gladkov898490c2019-04-29 18:11:14 +0200366
Andrii Nakryiko7fd78562019-08-13 11:54:42 -0700367btf_vmlinux_bin_o=""
Andrii Nakryiko341dfcf2019-08-12 11:39:47 -0700368if [ -n "${CONFIG_DEBUG_INFO_BTF}" ]; then
Kees Cookaf73d782020-03-03 18:18:34 -0800369 btf_vmlinux_bin_o=.btf.vmlinux.bin.o
370 if ! gen_btf .tmp_vmlinux.btf $btf_vmlinux_bin_o ; then
Stanislav Fomichevda5fb182019-11-27 08:14:10 -0800371 echo >&2 "Failed to generate BTF for vmlinux"
372 echo >&2 "Try to disable CONFIG_DEBUG_INFO_BTF"
373 exit 1
Andrii Nakryiko341dfcf2019-08-12 11:39:47 -0700374 fi
375fi
376
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200377kallsymso=""
Kees Cook8959e392019-08-13 08:15:32 -0700378kallsymso_prev=""
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200379kallsyms_vmlinux=""
380if [ -n "${CONFIG_KALLSYMS}" ]; then
381
382 # kallsyms support
383 # Generate section listing all symbols and add it into vmlinux
384 # It's a three step process:
385 # 1) Link .tmp_vmlinux1 so it has all symbols and sections,
386 # but __kallsyms is empty.
387 # Running kallsyms on that gives us .tmp_kallsyms1.o with
388 # the right size
389 # 2) Link .tmp_vmlinux2 so it now has a __kallsyms section of
390 # the right size, but due to the added section, some
391 # addresses have shifted.
392 # From here, we generate a correct .tmp_kallsyms2.o
Nicholas Piggin7e2b37c2016-11-24 03:41:37 +1100393 # 3) That link may have expanded the kernel image enough that
394 # more linker branch stubs / trampolines had to be added, which
395 # introduces new names, which further expands kallsyms. Do another
396 # pass if that is the case. In theory it's possible this results
397 # in even more stubs, but unlikely.
398 # KALLSYMS_EXTRA_PASS=1 may also used to debug or work around
399 # other bugs.
400 # 4) The correct ${kallsymso} is linked into the final vmlinux.
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200401 #
402 # a) Verify that the System.map from vmlinux matches the map from
403 # ${kallsymso}.
404
Kees Cook8959e392019-08-13 08:15:32 -0700405 kallsyms_step 1
406 kallsyms_step 2
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200407
Nicholas Piggin7e2b37c2016-11-24 03:41:37 +1100408 # step 3
Kees Cook8959e392019-08-13 08:15:32 -0700409 size1=$(${CONFIG_SHELL} "${srctree}/scripts/file-size.sh" ${kallsymso_prev})
410 size2=$(${CONFIG_SHELL} "${srctree}/scripts/file-size.sh" ${kallsymso})
Nicholas Piggin7e2b37c2016-11-24 03:41:37 +1100411
412 if [ $size1 -ne $size2 ] || [ -n "${KALLSYMS_EXTRA_PASS}" ]; then
Kees Cook8959e392019-08-13 08:15:32 -0700413 kallsyms_step 3
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200414 fi
415fi
416
Linus Torvaldsd7b08272019-09-20 08:36:47 -0700417vmlinux_link vmlinux "${kallsymso}" ${btf_vmlinux_bin_o}
Andrii Nakryikoe83b9f52019-04-02 09:49:50 -0700418
Jiri Olsac9a0f3b2020-07-11 23:53:24 +0200419# fill in BTF IDs
Jiri Olsa017dab32020-09-23 20:57:34 +0200420if [ -n "${CONFIG_DEBUG_INFO_BTF}" -a -n "${CONFIG_BPF}" ]; then
421 info BTFIDS vmlinux
422 ${RESOLVE_BTFIDS} vmlinux
Jiri Olsac9a0f3b2020-07-11 23:53:24 +0200423fi
424
Shile Zhang10916702019-12-04 08:46:31 +0800425if [ -n "${CONFIG_BUILDTIME_TABLE_SORT}" ]; then
426 info SORTTAB vmlinux
Shile Zhangf14bf6a2019-12-04 08:46:33 +0800427 if ! sorttable vmlinux; then
428 echo >&2 Failed to sort kernel tables
429 exit 1
430 fi
Linus Torvalds1347a2ce2012-05-28 10:32:28 -0700431fi
432
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200433info SYSMAP System.map
434mksysmap vmlinux System.map
435
436# step a (see comment above)
437if [ -n "${CONFIG_KALLSYMS}" ]; then
438 mksysmap ${kallsyms_vmlinux} .tmp_System.map
439
440 if ! cmp -s System.map .tmp_System.map; then
Michal Marek5369f552012-07-07 23:04:40 +0200441 echo >&2 Inconsistent kallsyms data
Michal Marek367e43c2012-08-10 11:55:11 +0200442 echo >&2 Try "make KALLSYMS_EXTRA_PASS=1" as a workaround
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200443 exit 1
444 fi
445fi
Rasmus Villemoes0b956e22021-03-05 11:02:12 +0100446
447# For fixdep
448echo "vmlinux: $0" > .vmlinux.d